local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1162)
do
	local data = {
		version = 7,
		key = "Kromog",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Kromog"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Kromog.BLP:35:35",
		triggers = {
			scan = {77692}, 
			encounterid = 1713,
			ejid = 1162,
		},
		onactivate = {
			tracing = {
				77692,
				markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 77692,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 540,
			timeflex = 540,
			timeheroic = 540,
			timemythic = 540,
		},
		userdata = {
			breathCount = 1,
			bosshp = 100,
			warned = 0,
			callOfTheMountainCount = 1,
			boss2 = 0,
			boss3 = 0,
			boss4 = 0,
		},
		timers = {
			timerFrenzy = {
				{
					"set",{bosshp = "&gethp|boss1&"},
				},
				{
					"expect",{"<bosshp>","<","35"},
					"expect",{"<warned>","==","0"},
					"set",{warned = 1},
					"message","mFrenzySoon",
				},
				{
					"expect",{"<bosshp>",">","34"},
					"scheduletimer",{"timerFrenzy",1},
				},
			},
		},		
		messages = {
			mFrenzySoon = {
				varname = format(L.alert["%s %s!"],SN[156861],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s!"],SN[156861],L.alert["soon"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 156861,
				icon = ST[156861],
			},	
			mFrenzy = {
				varname = format(L.alert["%s!"],SN[156861]),
				type = "message",
				text = format(L.alert["%s!"],SN[156861]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 156861,
				icon = ST[156861],
			},				
			mWarpedArmor = {
				varname = format(L.alert["%s %s %s (1)"],SN[156766],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[156766],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[156766],L.alert["on"]),
				color1 = "BROWN",
				sound = "ALERT13",
				desc = 156766,
				icon = ST[156766],
			},
			mGraspingEarth = {
				varname = format(L.alert["%s!"],SN[157060]),
				type = "message",
				text = format(L.alert["%s!"],SN[157060]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 157060,
				icon = ST[157060],
			},	
			mRuneofCrushingEarth = {
				varname = format(L.alert["%s!"],SN["ej9702"]),
				type = "message",
				text = format(L.alert["%s!"],SN["ej9702"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				ability = 9702,
				icon = EJST[9702],
			},	
			mStoneBreath = {
				varname = format(L.alert["%s (2)"],SN[156852]),
				type = "message",
				text = format(L.alert["%s (<breathCount>)"],SN[156852]),
				color1 = "RED",
				icon = ST[156852],
				sound = "ALERT13",
				desc = 156852,
			},
		},
		onstart = { 
			{
				"batchalert",{"StoneBreathCD","WarpedArmorCD","RipplingSmashCD","SlamCD","GraspingEarthCD"},
				"scheduletimer",{"timerFrenzy",1},
			},
			{
				"expect",{"&mythic&","==","true"},
				"alert","TremblingEarthCD",
			},
		},
		alerts = {
			GraspingEarthCD	= {
				varname = format(L.alert["%s Cooldown"],SN[157060]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157060]),
				time = 50,
				time2 = 112,
				color1 = "GLOBAL",
				icon = ST[157060],
				desc = 157060,	
			},
			StoneBreathCD = {
				varname = format(L.alert["%s Cooldown"],SN[156852]),
				type = "dropdown",
				text = "(<breathCount>) "..format(L.alert["%s Cooldown"],SN[156852]),
				time = 9,
				time2 = 24,
				time3 = 31,
				time4 = 61,
				time5 = 6,
				color1 = "GLOBAL",
				icon = ST[156852],
				desc = 156852,	
				--counter = true,
			},
			WarpedArmorCD = {
				varname = format(L.alert["%s Cooldown"],SN[156766]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156766]),
				time = 14,
				color1 = "GLOBAL",
				icon = ST[156766],
				desc = 156766,
				exhealer = true,
				exdps = true,
			},
			RipplingSmashCD	= {
				varname = format(L.alert["%s Cooldown"],SN[157592]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157592]),
				time = 23,
				time2 = 41,
				time3 = 24,
				time4 = 72,
				time5 = 17,
				color1 = "GLOBAL",
				icon = ST[157592],
				desc = 157592,	
			},
			SlamCD = {
				varname = format(L.alert["%s Cooldown"],SN[156704]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156704]),
				time = 17,
				time2 = 24,
				color1 = "GLOBAL",
				icon = ST[156704],
				desc = 156704,	
				exhealer = true,
				exdps = true,
			},
			TremblingEarthCD = {
				varname = format(L.alert["Next %s"],SN[173917]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[173917]),
				time = 82,
				time2 = 31,
				time3 = 125,
				color1 = "GLOBAL",
				icon = ST[173917],
				desc = 173917,	
			},	
			ThunderingBlowsCD = {
				varname = format(L.alert["Next %s"],SN[157054]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[157054]),
				time = 13,
				time2 = 7,
				color1 = "GLOBAL",
				icon = ST[157054],
				desc = 157054,	
			},	
			-- Warning
			wTremblingEarth = {
				varname = format(L.alert["%s!"],SN[173917]),
				type = "simple",
				text = format(L.alert["%s!"],SN[173917]),
				time = 2,
				color1 = "RED",
				icon = ST[173917],
				sound = "ALERT10",
				desc = 173917,
			},			
			wCallOfTheMountain = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[158217]),
				type = "simple",
				text = format(L.alert["%s %s (<callOfTheMountainCount>)"],L.alert["Incoming"],SN[158217]),
				time = 2,
				color1 = "RED",
				icon = ST[158217],
				sound = "ALERT10",
				desc = 158217,
			},			
			wSlam = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156704]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156704]),
				time = 2,
				color1 = "RED",
				icon = ST[156704],
				sound = "ALERT11",
				desc = 156704,
				extank = true,
				exmelee = true,
			},
			wRipplingSmash = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[157592]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[157592]),
				time = 2,
				color1 = "RED",
				icon = ST[157592],
				sound = "ALERT11",
				desc = 157592,
			},	
			wThunderingBlows = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[157054]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[157054]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[157054],
				sound = "ALERT13",
				desc = 157054,
			},		
			-- Casts
			TremblingEarthActive = {
				varname = format(L.alert["%s Active"],SN[173917]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[173917]),
				time = 25,
				color1 = "RED",
				icon = ST[173917],
				desc = 173917,
			},
			ThunderingBlowsCast = {
				varname = format(L.alert["%s Active"],SN[157054]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[157054]),
				time = 7,
				color1 = "GLOBAL",
				icon = ST[157054],
				desc = 157054,	
			},	
			CallOfTheMountainCast = { 
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[158217]),
				type = "dropdown",
				text = "(<callOfTheMountainCount>) "..format(L.alert["%s %s"],L.alert["Incoming"],SN[158217]),
				time = 5,
				time2 = 12,
				time3 = 31,
				color1 = "TAN",
				icon = ST[158217],
				desc = 158217,
			},		
			-- Debuff
			WarpedArmorDebuff = {
				varname = format(L.alert["%s Debuff"],SN[156766]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[156766]),
				text2 = format(L.alert["#5# (1): %s"],SN[156766]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[156766]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[156766]),
				time = 60,
				color1 = "BROWN",
				desc = 156766,
				icon = ST[156766],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- WarpedArmor
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156766},
				execute = {
					{
						"message","mWarpedArmor",
						"alert","WarpedArmorCD",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","WarpedArmorDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"WarpedArmorDebuff", text = 2},
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {156766},
				execute = {
					{
						"message",{"mWarpedArmor", text = 2},
						"alert","WarpedArmorCD",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"WarpedArmorDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"WarpedArmorDebuff", text = 4},
					},						
				},
			},
			-- StoneBreath
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156852},
				execute = {
					{
						"message","mStoneBreath",
						"alert",{"StoneBreathCD", time = 2},
						"set",{breathCount = "INCR|1"},
					},	
					--{
					--	"expect",{"<breathCount>","<","5"},
					--	"alert",{"StoneBreathCD", time = 2},
				--	},	
				},
			},		
			-- Slam
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156704},
				execute = {
					{
						"alert","wSlam", -- just tank e melees
						"alert",{"SlamCD", time = 2},
					},						
				},
			},
			-- RipplingSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157592},
				execute = {
					{
						"alert","wRipplingSmash",
					},
					{
						"expect",{"&mythic&","==","true"},
						"alert",{"RipplingSmashCD", time = 2},
					},
					{
						"expect",{"&mythic&","==","false"},
						"alert",{"RipplingSmashCD", time = 3},
					},
				},
			},
			-- GraspingEarth
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157060},
				execute = {
					{
						"message","mGraspingEarth",
						"alert",{"StoneBreathCD", time = 3},
						"set",{breathCount = 1},
						"alert",{"GraspingEarthCD", time = 2},
						"alert","ThunderingBlowsCD",
						"batchquash",{"WarpedArmorCD","SlamCD","RipplingSmashCD"},
						
					},						
				},
			},
			-- ThunderingBlows
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157054},
				execute = {
					{
						"alert","wThunderingBlows",
						"alert","ThunderingBlowsCast",
					},						
				},
			},	
			-- Frenzy
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156861},
				execute = {
					{
						"message","mFrenzy",
					},		
				},
			},		
			-- TremblingEarth
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {173917},
				execute = {
					{
						"set",{callOfTheMountainCount = 1},
						--"tracing",{77692,"&bossid|boss2&","&bossid|boss3&","&bossid|boss4&"},
						"batchquash",{"StoneBreathCD","RipplingSmashCD","WarpedArmorCD","SlamCD"},
						"batchalert",{"wTremblingEarth","TremblingEarthActive"},
						"alert",{"StoneBreathCD", time = 4},
						"alert",{"RipplingSmashCD", time = 4},
						"alert",{"CallOfTheMountainCast", time = 3},
					},	
				},
			},
			-- CallOfTheMountain
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158217},
				execute = {
					{
						"alert","wCallOfTheMountain",
						"set",{callOfTheMountainCount = "INCR|1"},
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {158217},
				execute = {
					{
						"expect",{"<callOfTheMountainCount>","<","4"},
						"alert",{"CallOfTheMountainCast", time = 2},
					},
					{
						"expect",{"<callOfTheMountainCount>",">","3"},
						--"tracing",{77692},
						"alert",{"TremblingEarthCD", time = 3},
						"alert",{"RipplingSmashCD", time = 5},
						"alert",{"StoneBreathCD", time = 5},
					},						
				},
			},	
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156980"}, -- Rune of Crushing Earth
								"message","mRuneofCrushingEarth",
							},								
						},
					},					
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end