local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local Firecaller = select(2,EJ_GetCreatureInfo(6,1154))
local Regulator = select(2,EJ_GetCreatureInfo(5,1154))
local Operator = select(2,EJ_GetCreatureInfo(4,1154))
local Engineer = select(2,EJ_GetCreatureInfo(3,1154))
local Guard = select(2,EJ_GetCreatureInfo(2,1154))

local EJName = EJ_GetEncounterInfo(1154)

do
	local data = {
		version = 10,
		key = "TheBlastFurnace",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["The Blast Furnace"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-The Blast Furnace.BLP:35:35",
		respawntime = 10,
		triggers = {
			scan = {76809,76806}, --76809 foreman feldspar, 76806 heart of the mountain, 
								  --76808 Heat Regulator, 76810 Furnace Engineer, 76811 Bellows Operator, 
								  --76815 Primal Elementalist, 78463 Slag Elemental, 76821 Firecaller
			encounterid = 1690,
			ejid = 1154,
		},
		onactivate = {
			tracing = {
			"boss1", 76809, "boss3", "boss4", -- both Heat Regulator
			powers={true},
			--alternatepower={true},
			--markers1 = {25,55,85},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2","boss3","boss4","boss5"},
			defeat = 76806,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
		--	timelfr = 780,
			timeflex = 780,
			timeheroic = 780,
			timemythic = 780,
		},
		arrows = {
			VolatileFireArrow = {
				varname = SN[176121],
				unit = "&closest|volatileFireunits2&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[176121],
				range1 = 5,
				range2 = 7,
				range3 = 10,
				desc = 176121,
				icon = ST[176121],
			},
		},	
		userdata = {
			startTime = 0,
			machinesDead = 0,
			elementalistsDead = 0,
			powerRate = 4,
			totalTime = 25,
			power = 100,
			powern = 100,
			warned = 0,
			newTime = 30,
			blastTime = 30,
			blastTimecd = 30,
			bombOnMe = 0,
			fixateOnMe = 0,
			prev = 0,
			cd = 0,
			superheatedcd = 0,
			Bombunits = {type = "container"},
			Bombunits2 = {type = "container"},
			Fixateunits = {type = "container"},
			Fixateunits2 = {type = "container"},
			MeltArmorunits = {type = "container", wipein = 3},
			Heatunits = {type = "container", wipein = 3},
			regulatorDeaths = 0,
			shamanDeaths = 0,
			volatileFireOnMe = 0,
			firstOperators = 0,
			volatileFireunits = {type = "container"},
			volatileFireunits2 = {type = "container"},
			engineerFireunits = {type = "container"},
			unitpowerenabled = 1,
		},
		timers = {
			timerRadar = {
				{
					"expect",{"&count|volatileFireunits2&",">","0"},
					"openwindow",{"9","&list|volatileFireunits2&",true,176121},
				},
				{
					"expect",{"&count|Bombunits2&",">","0"},
					"openwindow",{"9","&list|Bombunits2&",true,155192},
				},
				{
					"expect",{"<volatileFireOnMe>","==","1"},
					"openwindow",{"9",nil,false,176121},
				},				
				{
					"expect",{"<fixateOnMe> &mythic&","==","1 true"},
					"openwindow",{"5",nil,false,155196},
				},
				{
					"expect",{"<bombOnMe>","==","1"},
					"openwindow",{"9",nil,false,155192},
				},				
			},
			timerBomb = {
				{
					"message","mBomb",
				},
			},
			timerVolatileFire = {
				{
					"message","mVolatileFire",
				},
			},			
			timerFixate = {
				{
					"message","mFixate",
				},
			},
			timerMeltArmor = {
				{
					"message","mMeltArmor",
				},
			},	
			timerHeat = {
				{
					"message","mHeat",
				},
			},				
			timerEngineer = {
				{
					"message","mEngineer",
				},
				{
					"expect",{"&heroic&","==","true"},
					"canceltimer","timerEngineer",
					"scheduletimer",{"timerEngineer",40},
					"alert",{"NextEngineer", time = 3},
				},
				{
					"expect",{"&heroic&","==","false"},
					"canceltimer","timerEngineer",
					"scheduletimer",{"timerEngineer",35},	
					"alert","NextEngineer",
				},		
			},
			timerSecurityRepeater = {
				{
					"message","mGuard",
				},
				{
					"expect",{"<regulatorDeaths>",">","1"},
					"canceltimer","timerSecurityRepeater",
					"scheduletimer",{"timerSecurityRepeater",40},
					"alert",{"NextGuard", time = 3},
				},
				{
					"expect",{"<regulatorDeaths>","<","2"},
					"canceltimer","timerSecurityRepeater",
					"scheduletimer",{"timerSecurityRepeater",30},	
					"alert",{"NextGuard", time = 6},
				},				
			},	
			timerFirecaller = {
				{
					"message","mFirecaller",
					"alert",{"NextFirecaller", time = 2},
					"canceltimer","timerFirecaller",
					"scheduletimer",{"timerFirecaller",45},	
				},
			},				
		},	
		announces = { 
			Bombsay = {
				varname = format(L.alert["%s %s %s!"],SN[155192],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155192],L.alert["on"],L.alert["Me"]),
				desc = 155192,
				icon = ST[155192],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			VolatileFiresay = {
				varname = format(L.alert["%s %s %s!"],SN[176121],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[176121],L.alert["on"],L.alert["Me"]),
				desc = 176121,
				icon = ST[176121],
				exlfr = true,
			},
			Rupturesay = {
				varname = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["Me"]),
				desc = 156934,
				icon = ST[156934],
			},	
			Meltsay = {
				varname = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["Me"]),
				desc = 155225,
				icon = ST[155225],
			},				
		},
		messages = {
			mHeat = {
				varname = format(L.alert["%s %s %s"],SN[155242],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Heatunits&"],SN[155242],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 155242,
				icon = ST[155242],
			},			
			mMeltArmor = {
				varname = format(L.alert["%s %s %s"],SN[175104],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MeltArmorunits&"],SN[175104],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 175104,
				icon = ST[175104],
			},		
			mBomb = {
				varname = format(L.alert["%s %s %s"],SN[155192],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Bombunits&"],SN[155192],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 155192,
				icon = ST[155192],
				enabled = false,
			},
			mVolatileFire = {
				varname = format(L.alert["%s %s %s"],SN[176121],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|volatileFireunits&"],SN[176121],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 176121,
				icon = ST[176121],
				enabled = false,
			},			
			mFixate = {
				varname = format(L.alert["%s %s %s"],SN[155196],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Fixateunits&"],SN[155196],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 155196,
				icon = ST[155196],
			},	
			mRupture = {
				varname = format(L.alert["%s %s %s"],SN[156934],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156934],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 156934,
				icon = ST[156934],
			},					
			mBellowsOperator = {
				varname = format(L.alert["%s!"],Operator),
				type = "message",
				text = format(L.alert["%s!"],Operator),
				color1 = "RED",
				sound = "ALERT13",
				ability = 9650,
				icon = ST[155181],
			},	
			mSuperheated = {
				varname = format(L.alert["%s!"],SN[163776]),
				type = "message",
				text = format(L.alert["%s!"],SN[163776]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 163776,
				icon = ST[163776],
			},	
			mRegulatorDeaths = {
				varname = format(L.alert["%s (2/2)"],Regulator),
				type = "message",
				text = format(L.alert["#5# (<regulatorDeaths>/2)"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				--desc = 163776,
				icon = ST[163776],
			},	
			mShamanDeaths = {
				varname = format(L.alert["%s (2/4)"],L.npc_BlackrockFoundry["Heat Regulator"]),
				type = "message",
				text = format(L.alert["#5# (<shamanDeaths>/4)"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				--desc = 163776,
				icon = ST[163776],
			},
			mBlast = {
				varname = format(L.alert["%s %s!"],SN[155209],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s!"],SN[155209],L.alert["soon"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 155209,
				icon = ST[155209],
				extank = true,
				exdps = true,
				throttle = 6,
			},	
			mGuard = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],Guard),	
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],Guard),	
				color1 = "ORANGE",
				sound = "ALERT13",
				icon = ST[160382],
			},
			mEngineer = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],Engineer),	
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],Engineer),	
				color1 = "CYAN",
				sound = "ALERT13",
				icon = ST[63603],
			},
			mFirecaller = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],Firecaller),	
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],Firecaller),	
				color1 = "GOLD",
				sound = "ALERT13",
				icon = ST[24826],
			},			
		},
		onstart = {
			{
				"set",{startTime = "&gettime&"},
				"set",{blastTimecd = 30},
				"set",{powerRate = 3.33},
				"set",{totalTime = 30},
				"set",{blastTime = 30},
				"alert",{"BlastCD", time = 4},
				--"scheduletimer",{"timerPower",1},
			},
			{
				"expect",{"&lfr&","==","true"},
				"alert",{"NextEngineer", time = 2},
				"alert",{"NextGuard", time = 2},
				"alert",{"NextBellowsOperator", time = 2},
				"scheduletimer",{"timerEngineer",65},
				"scheduletimer",{"timerSecurityRepeater",65},	
			},
			{
				"expect",{"&mythic&","==","true"},
				"set",{blastTime = 25},
				"alert",{"NextEngineer", time = 3},
				"alert",{"NextGuard", time = 3},
				"alert",{"NextBellowsOperator", time = 3},
				"scheduletimer",{"timerEngineer",40},
				"scheduletimer",{"timerSecurityRepeater",40},					
			},
			{
				"expect",{"&flex&","==","true"},
				"alert",{"NextEngineer", time = 4},
				"alert",{"NextGuard", time = 4},
				"alert",{"NextBellowsOperator", time = 4},
				"scheduletimer",{"timerEngineer",60},
				"scheduletimer",{"timerSecurityRepeater",60},	
			},	
			{
				"expect",{"&heroic&","==","true"},
				"alert",{"NextEngineer", time = 5},
				"alert",{"NextGuard", time = 5},
				"alert",{"NextBellowsOperator", time = 5},
				"scheduletimer",{"timerEngineer",55},
				"scheduletimer",{"timerSecurityRepeater",55},					
			},				
		},
		alerts = {
			BlastCD = {
				varname = format(L.alert["%s Cooldown"],SN[155209]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155209]),
				time = 57,
				time2 = 30,
				time3 = 25,
				time4 = "<blastTimecd>",
				color1 = "GLOBAL",
				icon = ST[155209],
				desc = 155209,
				throttlespecial = 10,
			},
			NextEngineer = {
				varname = format(L.alert["Next %s"],Engineer),
				type = "dropdown",
				text = format(L.alert["Next %s"],Engineer),
				time = 35,
				time2 = 65,
				time3 = 40,
				time4 = 60,
				time5 = 55,				
				color1 = "GLOBAL",
				icon = ST[63603],
			},	
			NextBellowsOperator = {
				varname = format(L.alert["Next %s"],Operator),
				type = "dropdown",
				text = format(L.alert["Next %s"],Operator),
				time = 64,
				time2 = 65.5,
				time3 = 40,
				time4 = 60,
				time5 = 55,					
				color1 = "GLOBAL",
				icon = ST[155181],	
				throttle = 5,
			},	
			NextGuard = {
				varname = format(L.alert["Next %s"],Guard),
				type = "dropdown",
				text = format(L.alert["Next %s"],Guard),
				time = 64,
				time2 = 65,
				time3 = 40,
				time4 = 60,
				time5 = 55,	
				time6 = 30,
				time7 = 70,
				color1 = "GLOBAL",
				icon = ST[160382],	
			},	
			NextFirecaller = {
				varname = format(L.alert["Next %s"],Firecaller),
				type = "dropdown",
				text = format(L.alert["Next %s"],Firecaller),
				time = 75,	
				time2 = 45,
				color1 = "GLOBAL",
				icon = ST[24826],	
			},
			SuperheatedCD = {
				varname = format(L.alert["%s Cooldown"],SN[163776]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163776]),
				time = "<superheatedcd>",
				color1 = "GLOBAL",
				icon = ST[163776],
				desc = 163776,
			},
			-- Warning
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "YELLOW",
				icon = EJST[9650],
				sound = "ALERT13",
			},
			Phase3 = {
				varname = format(L.alert["Phase 3"]),
				type = "simple",
				text = format(L.alert["Phase 3"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[163776],
				sound = "ALERT11",
			},			
			wRepair = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155179]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155179]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155179],
				sound = "ALERT10",
				desc = 155179,
				exhealer = true,
			},
			wSlagBomb = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[176133]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[176133]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[176133],
				sound = "ALERT10",
				desc = 176133,
			},
			wPyroclasm = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156937]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156937]),
				time = 2,
				color1 = "RED",
				icon = ST[156937],
				sound = "ALERT11",
				desc = 156937,
			},
			wShieldRemoved = {
				varname = format(L.alert["%s %s!"],SN[155176],L.alert["Removed"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[155176],L.alert["Removed"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[155176],
				sound = "ALERT14",
				desc = 155176,
			},					
			--[[wCauterizeWounds = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155186]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155186]),
				time = 2,
				color1 = "RED",
				icon = ST[155186],
				sound = "ALERT10",
				desc = 155186,
			},	--]]		
			-- Inform
			iReactiveEarthShield = {
				varname = format(L.alert["%s %s %s %s!"],L.alert["Dispell"],SN[155173],L.alert["on"],L.alert["Boss"]),
				type = "inform",
				text = format(L.alert["%s %s %s #5#!"],L.alert["Dispell"],SN[155173],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155173],
				sound = "ALERT13",
				desc = 155173,
			},			
			iBomb = {
				varname = format(L.alert["%s %s %s, %s!"],SN[155192],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[155192],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155192],
				sound = "ALERT12",
				desc = 155192,
				flashscreen = true,
			},
			iVolatileFire = {
				varname = format(L.alert["%s %s %s, %s!"],SN[176121],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[176121],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[176121],
				sound = "ALERT12",
				desc = 176121,
				flashscreen = true,
			},			
			iFixate = {
				varname = format(L.alert["%s %s %s!"],SN[155196],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[155196],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[155196],
				sound = "ALERT11",
				desc = 155196,
				flashscreen = true,
			},	
			iMelt = {
				varname = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "GLOBAL",
				icon = ST[155225],
				sound = "ALERT10",
				desc = 155225,
				flashscreen = true,
			},
			iMeltUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[155225],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[155225],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "GLOBAL",
				icon = ST[155225],
				sound = "ALERT12",
				desc = 155225,
				flashscreen = true,
				throttle = 2,
			},	
			iRupture = {
				varname = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[156934],
				sound = "ALERT10",
				desc = 156934,
				flashscreen = true,
			},
			iRuptureUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[156932],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156932],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156932],
				sound = "ALERT12",
				desc = 156932,
				flashscreen = true,
				throttle = 2,
			},				
			iShieldsDown = {
				varname = format(L.alert["%s %s!"],SN["ej9655"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9655"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[9655],
				ability = 9655,
				exhealer = true,
				extank = true,
				throttle = 10,
			},	
			--[[iBellowsOperator = {
				varname = format(L.alert["%s %s!"],SN["ej9650"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9650"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[9650],
				ability = 9650,
				exhealer = true,
				throttle = 10,
			},	--]]
			iHeartoftheMountain = {
				varname = format(L.alert["%s %s!"],SN["ej10808"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej10808"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[10808],
				ability = 10808,
				exhealer = true,
				exdps = true,
			},				
			-- Casts
			ShieldsDownActive = {
				varname = format(L.alert["%s Active"],SN[158345]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[158345]),
				time = 30,
				time2 = 40,
				time3 = 20,
				color1 = "GLOBAL",
				icon = ST[158345],
				desc = 158345,
				--exhealer = true,
				--extank = true,
				throttle = 10,
			},
			MeltActive = {
				varname = format(L.alert["%s Active"],SN[155225]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155225]),
				time = 10,
				color1 = "BROWN",
				icon = ST[155225],
				desc = 155225,
			},			
			RuptureActive = {
				varname = format(L.alert["%s Active"],SN[156934]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156934]),
				time = 5,
				color1 = "YELLOW",
				icon = ST[156934],
				desc = 156934,
			},			
			BombActive = {
				varname = format(L.alert["%s Duration"],SN[155192]),
				type = "centerpopup",
				text = format(L.alert["%s Duration"],SN[155192]),
				time = 15,
				color1 = "RED",
				icon = ST[155192],
				desc = 155192,
			},
			VolatileFireActive = {
				varname = format(L.alert["%s Duration"],SN[176121]),
				type = "centerpopup",
				text = format(L.alert["%s Duration"],SN[176121]),
				time = "<volatilecd>",
				color1 = "ORANGE",
				icon = ST[176121],
				desc = 176121,
			},	
			SlagBombIncoming = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[176133]),
				type = "centerpopup",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[176133]),
				time = 2,
				color1 = "GOLD",
				icon = ST[176133],
				desc = 176133,
			},			
			-- Debuff
			BombDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155192]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[155192]),
				text2 = format(L.alert["#5#: %s"],SN[155192]),
				time = 15,
				color1 = "PURPLE",
				desc = 155192,
				icon = ST[155192],
				tag = "#5#",
				exdps = true,				
			},	
			VolatileFireDebuff = {
				varname = format(L.alert["%s Debuff"],SN[176121]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[176121]),
				text2 = format(L.alert["#5#: %s"],SN[176121]),
				time = "<volatilecd>",
				color1 = "RED",
				desc = 176121,
				icon = ST[176121],
				tag = "#5#",
				exdps = true,		
				enabled = false,
			},
			--[[MeltArmorDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175104]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[175104]),
				text2 = format(L.alert["#5# (1): %s"],SN[175104]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[175104]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[175104]),
				time = 10,
				color1 = "TAN",
				desc = 175104,
				icon = ST[175104],
				tag = "#5#",
				exdps = true,				
			},--]]	
			HeatDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155242]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155242]),
				text2 = format(L.alert["#5# (1): %s"],SN[155242]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155242]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155242]),
				time = 10,
				color1 = "ORANGE",
				desc = 155242,
				icon = ST[155242],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {
			-- Bomb 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155192, 174716, 159558},
				execute = {
					{
						"expect",{"&contains|Bombunits2|#5#&","==","false"},
						"insert",{"Bombunits","#5#"},
						"insert",{"Bombunits2","#5#",true},
						"canceltimer","timerBomb",
						"scheduletimer",{"timerBomb",1.25},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"BombActive","BombDebuff","iBomb"},
						"announce","Bombsay",
						"set",{bombOnMe = 1},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"BombDebuff", text = 2},
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REFRESH",
				spellid = {155192, 174716, 159558},
				execute = {
					{
						"expect",{"&contains|Bombunits2|#5#&","==","false"},
						"invoke",{
							{
								"insert",{"Bombunits","#5#"},
								"insert",{"Bombunits2","#5#",true},
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"batchalert",{"BombActive","BombDebuff","iBomb"},
								"announce","Bombsay",
								"set",{bombOnMe = 1},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"BombDebuff", text = 2},
							},
							{
								"scheduletimer",{"timerRadar",0.1},
							},							
						},
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155192, 174716, 159558},
				execute = {
					{
						"delete",{"Bombunits","#5#"},
						"delete",{"Bombunits2","#5#"},
						"quash","BombDebuff"
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","BombActive",
						"set",{bombOnMe = 0},
						"closewindow",
					},
					{
						"expect",{"&count|Bombunits2&","==","0"},
						"closewindow",
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},				
			-- ShieldsDown 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158345},
				execute = {
					{
						"alert","iShieldsDown",
						"alert","wShieldRemoved",
					},			
					{
						"expect",{"&flex&","==","true"},
						"alert",{"ShieldsDownActive", time = 2}, -- 40
					},
					{
						"expect",{"&flex&","~=","true"},
						"invoke",{
							{
								"expect",{"&mythic&","==","true"},
								"alert",{"ShieldsDownActive", time = 3}, -- 20
							},
							{
								"expect",{"&mythic&","==","false"}, -- 30
								"alert","ShieldsDownActive",
							},							
						},
					},							
				},
			},
			-- Repair
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155179},
				execute = {
					{
						"alert","wRepair",
					},			
				},
			},	
			-- BellowsOperator Loading
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155181},
				throttle = 5,
				execute = {
					{
						--"expect",{"&getprev|<prev>&",">","5"},
						--"set",{prev = "&gettime&"},
						"expect",{"<firstOperators>","==","1"},
						"alert","NextBellowsOperator",
						"message","mBellowsOperator",
					},
					{
						"expect",{"<firstOperators>","~=","1"},
						"set",{firstOperators = 1},
					},					
				},
			},	
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155196},
				--dstisplayerunit = true,
				execute = {
					{
						"expect",{"&contains|Fixateunits2|#5#&","==","false"},
						"insert",{"Fixateunits","#5#"},
						"insert",{"Fixateunits2","#5#",true},
						"canceltimer","timerFixate",
						"scheduletimer",{"timerFixate",1},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iFixate",
						"set",{fixateOnMe = 1},
					},				
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155196},
				--dstisplayerunit = true,
				execute = {
					{
						"delete",{"Fixateunits","#5#"},
						"delete",{"Fixateunits2","#5#"},					
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"set",{fixateOnMe = 0},
						"closewindow",
					},	
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},				
			-- SlagBomb
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {176133},
				execute = {
					{
						"batchalert",{"SlagBombIncoming","wSlagBomb"},
					},			
				},
			},
			-- ReactiveEarthShield
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155173},
				execute = {
					{
						"expect",{"&npcid|#4#& &ismagicdispeller&","==","76815 true"},
						"alert","iReactiveEarthShield",
					},
		
				},
			},
			-- CauterizeWounds
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155186},
				execute = {
					{
						"alert","wCauterizeWounds",
					},			
				},
			},	--]]	
			-- VolatileFire 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {176121},
				execute = {
					{
						"expect",{"&contains|volatileFireunits2|#5#&","==","false"},
						"insert",{"volatileFireunits","#5#"},
						"insert",{"volatileFireunits2","#5#",true},
						"canceltimer","timerVolatileFire",
						"scheduletimer",{"timerVolatileFire",0.5},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"set",{volatilecd = "&playerdebuffdur|"..SN[176121].."&"},
						--"invoke",{
						--	{
						--		"expect",{"<volatilecd>",">","0"},
						--	},
						--},
						"batchalert",{"VolatileFireActive","VolatileFireDebuff","iVolatileFire"},
						"announce","VolatileFiresay",
						"set",{volatileFireOnMe = 1},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"set",{volatilecd = "&targetdebuffdur|#5#|"..SN[176121].."&"},
						"alert",{"VolatileFireDebuff", text = 2},
						"invoke",{
							{
								"expect",{"&playerdebuff|"..SN[155196].."&","==","false"}, -- Fixated
								"arrow","VolatileFireArrow",
							},
						},
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {176121},
				execute = {
					{
						"expect",{"&targetdebuff|#5#|"..SN[176121].."&","==","false"},
						"invoke",{
							{
								"delete",{"volatileFireunits","#5#"},
								"delete",{"volatileFireunits2","#5#"},
								"quash","VolatileFireDebuff"
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"quash","VolatileFireActive",
								"set",{volatileFireOnMe = 0},
								"closewindow",
							},
							{
								"expect",{"&count|volatileFireunits2&","==","0"},
								"closewindow",
							},
							{
								"scheduletimer",{"timerRadar",0.1},
							},
						},
					},
				},
			},		
			-- Pyroclasm
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156937},
				execute = {
					{
						"alert","wPyroclasm",
					},			
				},
			},	
			-- MeltArmor 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175104},
				execute = {
					{
						"insert",{"MeltArmorunits","#5#"},
						"canceltimer","timerMeltArmor",
						"scheduletimer",{"timerMeltArmor",0.5},							
					},
					--[[{
						"expect",{"#4#","==","&playerguid&"},
						"alert","MeltArmorDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 2},
					},--]]
				},
			},
		--[[	{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {175104},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 4},
					},
				},
			},--]]
			-- Rupture 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156934},
				--dstisplayerunit = true,
				execute = {
					{
						"message","mRupture",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"iRupture","RuptureActive"},
						"announce","Rupturesay",
					},				
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156932},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuptureUnder",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156932},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuptureUnder",
					},
				},
			},
			-- Heat 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155242},
				execute = {
					{
						"insert",{"Heatunits","#5#"},
						"canceltimer","timerHeat",
						"scheduletimer",{"timerHeat",0.5},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","HeatDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"HeatDebuff", text = 2},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155242},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"HeatDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"HeatDebuff", text = 4},
					},
				},
			},
			-- Melt 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155225},
				dstisplayerunit = true,
				execute = {
					{
						"batchalert",{"iMelt","MeltActive"},
						"announce","Meltsay",					
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {155223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMeltUnder",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {155223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMeltUnder",
					},
				},
			},
			-- Superheated 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163776},
				execute = {
					{
						"message","mSuperheated",
						"set",{unitpowerenabled = 0}, -- Disable unitpower
						"set",{newTime = 6},
					},
					{
						"expect",{"&mythic&","==","true"},
						"set",{newTime = 5},
					},
					{
						"expect",{"<newTime>","~=","<blastTime>"},
						"set",{blastTime = "<newTime>"},
						"set",{blastTimecd = "&checkPower|boss1|<newTime>&"},
						"alert",{"BlastCD", time = 4},
					},						
				},
			},
			
			-----
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","76808"}, --regulator
						"set",{regulatorDeaths = "INCR|1"},
						"message","mRegulatorDeaths",
						"invoke",{
							{
								"expect",{"<regulatorDeaths>",">","1"},
								"quash","NextBellowsOperator",
								"quash","NextEngineer",
								"canceltimer","timerEngineer",
								"canceltimer","timerSecurityRepeater",
								"alert",{"NextGuard", time = 7},
								"alert","NextFirecaller",
								"scheduletimer",{"timerSecurityRepeater",70},									
								"scheduletimer",{"timerFirecaller",75},
								--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
								"unittracing",{"boss1","boss2","boss3","boss4","boss5"},
								"alert","Phase2",
							},
						},
					},					
					{
						"expect",{"&npcid|#4#&","==","76815"}, -- Shaman
						"set",{shamanDeaths = "INCR|1"},
						"message","mShamanDeaths",
						"quash","ShieldsDownActive",
						"invoke",{
							{
								"expect",{"<shamanDeaths>",">","3"},
								"alert","Phase3",
								--"tracing",{76806},
								"unittracing",{"boss1"},
								"canceltimer","timerFirecaller",
								"canceltimer","timerSecurityRepeater",								
								"batchquash",{"NextGuard","NextFirecaller"},
								"invoke",{
									{
										"expect",{"<startTime>","~=","0"},
										"set",{superheatedcd = 600},
										"set",{prev = "&gettime|<startTime>&"},
										"set",{superheatedcd = "DECR|<prev>"},
										"alert","SuperheatedCD",
									},
								},
							},
						},
					},
					--{
					--	"expect",{"&npcid|#4#&","==","76809"}, -- foreman feldspar
					--	"tracing",{"boss1","boss2","boss3"},
					--},						
				},
			},
			{
                type = "event",
                event = "UNIT_POWER_FREQUENT",
                execute = {
					{
						"expect",{"#1# #2# <unitpowerenabled>","==","boss1 ALTERNATE 1"},
						"set",{power = "&getap|boss1&"},
						"set",{newTime = 30},
						"invoke",{
							{
								"expect",{"&mythic&","==","true"},
								"set",{newTime = 25},
							},
							{
								"expect",{"<power>","==","100"},
								"set",{newTime = 6},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"set",{newTime = 5},
									},
								},
							},					
							{
								"expect",{"<power>",">","74"},
								"set",{newTime = 9},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"set",{newTime = 8},
									},
								},
							},
							{
								"expect",{"<power>",">","49"},
								"set",{newTime = 15},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"set",{newTime = 12},
									},
								},
							},
							{
								"expect",{"<power>",">","24"},
								"set",{newTime = 20},
								"invoke",{
									{
										"expect",{"&mythic&","==","true"},
										"set",{newTime = 18},
									},
								},
							},
							{
								"expect",{"<newTime>","~=","<blastTime>"},
								--"set",{blastTime = "&checkPower|boss1|<newTime>&"},
								--"set",{newTime = "<blastTime>"},
								"set",{blastTime = "<newTime>"},
								"set",{blastTimecd = "&checkPower|boss1|<newTime>&"},
								--"debug",{"blastsoon","<blastTime>","<blastTimecd>"},
								--"alert",{"BlastCD", time = 4},
								--"settimeleft",{"BlastCD","<blastTimecd>"},
								"set",{cd = "&timeleft|BlastCD|0&"},
								"invoke",{
									{
										"expect",{"<cd>","~=","-1"},
										"settimeleft",{"BlastCD","<blastTimecd>"},
									},
									{
										"expect",{"<cd>","==","-1"},
										"alert",{"BlastCD", time = 4},
									},
								},								
							},					
						},
					},
					{
						"expect",{"#1# <unitpowerenabled>","==","boss1 1"},
						"set",{powern = "&getup|boss1&"},
						"invoke",{
							{
								"expect",{"<powern>",">","80"},
								"expect",{"<powern>","<","100"},
								"set",{warned = 1},
								"invoke",{
									{
										"expect",{"<blastTime>",">","10"},
										"message","mBlast",
									},
								},
							},	
							{
								"expect",{"<powern> <warned>","==","0 1"},
								"set",{warned = 0},
								"set",{cd = "&timeleft|BlastCD|0&"},
								--"settimeleft",{"BlastCD","<blastTime>"},
								"invoke",{
									{
										"expect",{"<cd>","~=","-1"},
										"settimeleft",{"BlastCD","<blastTime>"},
									},
									{
										"expect",{"<cd>","==","-1"},
										"alert",{"BlastCD", time = 4},
									},
								},
							},						
						},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end