local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

-- Darkshard Gnasher
do
	local data = {
		version = 1,
		key = "blackrocktrash",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Darkshard Gnasher"],
		triggers = {
			scan = {78978}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {78978},
		--	defeat = 78978,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},		
		messages = {
			mInsatiableHunger = {
				varname = format(L.alert["%s %s %s"],SN[159632],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[159632],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 159632,
				icon = ST[159632],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			-- Inform
			iInsatiableHunger = {
				varname = format(L.alert["%s %s %s!"],SN[159632],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[159632],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[159632],
				sound = "ALERT10",
				desc = 159632,
				flashscreen = true,
				--throttle = 3,
			},
			-- Casts
			InsatiableHungerCast = {
				varname = format(L.alert["%s Active"],SN[159632]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[159632]),
				time = 8,
				color1 = "RED",
				icon = ST[159632],
				desc = 159632,
			},
			-- Debuff
			InsatiableHungerDebuff = {
				varname = format(L.alert["%s Debuff"],SN[159632]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[159632]),
				text2 = format(L.alert["#5#: %s"],SN[159632]),
				time = 8,
				color1 = "PURPLE",
				desc = 159632,
				icon = ST[159632],
				tag = "#5#",			
			},	
		},
		events = {
			-- InsatiableHunger
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159632},
				execute = {
					{
						"message","mInsatiableHunger",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"InsatiableHungerDebuff", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"InsatiableHungerCast","iInsatiableHunger","InsatiableHungerDebuff"},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {159632},
				execute = {
					{
						"quash","InsatiableHungerDebuff",
					},				
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end

-- Blackrock Enforcer
do
	local data = {
		version = 1,
		key = "blackrocktrash2",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Blackrock Enforcer"],
		triggers = {
			scan = {79208}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {79208},
			--defeat = 79208,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		onstart = {
			{

			},
		},
		alerts = {
			-- Inform
			iFireBomb = {
				varname = format(L.alert["%s %s, %s!"],SN[160260],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[160260],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[160260],
				sound = "ALERT12",
				desc = 160260,
				flashscreen = true,
				throttle = 1.5,
			},	
		},
		events = {
			-- FireBomb
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {160260},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFireBomb",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {160260},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFireBomb",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {160260},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFireBomb",
					},
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end

-- Blast Furnace Exhaust
do
	local data = {
		version = 2,
		key = "blackrocktrash3",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Blast Furnace Exhaust"],
		triggers = {
			scan = {78832}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {78832},
			--defeat = 78832,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		onstart = {
			{

			},
		},
		alerts = {
			-- Inform
			iExhaustFumes = {
				varname = format(L.alert["%s %s, %s!"],SN[174773],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[174773],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[174773],
				sound = "ALERT12",
				desc = 174773,
				flashscreen = true,
				throttle = 1.5,
			},	
		},
		events = {
			-- ExhaustFumes
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {174773},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iExhaustFumes",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {174773},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iExhaustFumes",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {174773},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iExhaustFumes",
					},
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end


-- Ogron Hauler
do
	local data = {
		version = 1,
		key = "blackrocktrash4",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Ogron Hauler"],
		triggers = {
			scan = {87719}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {87719},
			--defeat = 87719,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},		
		messages = {
			mOverheadSmash = {
				varname = format(L.alert["%s %s %s"],SN[175765],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[175765],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 175765,
				icon = ST[175765],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			-- Debuff
			OverheadSmashDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175765]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[175765]),
				text2 = format(L.alert["#5#: %s"],SN[175765]),
				time = 10,
				color1 = "GOLD",
				desc = 175765,
				icon = ST[175765],
				tag = "#5#",			
			},				
		},
		events = {
			-- OverheadSmash
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175765},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"message","mOverheadSmash",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"OverheadSmashDebuff", text = 2},
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","OverheadSmashDebuff",
							},
						},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


-- Forgemistress Flamehand
do
	local data = {
		version = 3,
		key = "blackrocktrash5",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Forgemistress Flamehand"],
		triggers = {
			scan = {87989}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {87989},
			--defeat = 87989,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		arrows = {
			LivingBlazearrow = {
				varname = SN[175583],
				unit = "#5#",
				persist = 10,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[175583],
				range1 = 1,
				range2 = 5,
				range3 = 7,
				desc = 175583,
				icon = ST[175583],
			},	
		},
		announces = { 
			LivingBlazesay = {
				varname = format(L.alert["%s %s %s!"],SN[175583],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[175583],L.alert["on"],L.alert["Me"]),
				desc = 175583,
				icon = ST[175583],
				--flashcolor = "RED",
				--flashscreen = true,
			},
		},		
		messages = {
			mBurning = {
				varname = format(L.alert["%s %s %s (2)"],SN[175594],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[175594],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 175594,
				icon = ST[175594],
				throttle = 5,
				exdps = true,
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			LivingBlazeCD = {
				varname = format(L.alert["%s Cooldown"],SN[175583]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[175583]),
				time = 23,
				color1 = "GLOBAL",
				icon = ST[175583],
				desc = 175583,
			},	
			-- Inform
			iLivingBlaze = {
				varname = format(L.alert["%s %s %s!"],SN[175583],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[175583],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[175583],
				sound = "ALERT13",
				desc = 175583,
				flashscreen = true,
			},
			iBurning = {
				varname = format(L.alert["%s %s!"],SN[175594],L.alert["over"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[175594],L.alert["over"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[175594],
				sound = "ALERT13",
				desc = 175594,
			},				
			-- Debuff
			LivingBlazeDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175583]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[175583]),
				text2 = format(L.alert["#5#: %s"],SN[175583]),
				time = 10,
				color1 = "PURPLE",
				desc = 175583,
				icon = ST[175583],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {
			-- LivingBlaze
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {175583},
				execute = {
					{
						"alert","LivingBlazeCD",
					},			
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175583},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"iLivingBlaze","LivingBlazeDebuff"},
						"openwindow",{"6",nil,false,175583},
						"invoke",{
							{
								"expect",{"&lfr&","==","false"},
								"announce","LivingBlazesay",
							},
						},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"LivingBlazeDebuff", text = 2},
						"arrow","LivingBlazearrow",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {175583},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
					},
					{
						"quash","LivingBlazeDebuff",
						"removearrow","#5#",
					},
				},
			},	
			-- Burning
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {175594},
				execute = {
					{
						"expect",{"&checkperc|#11#|3&","==","0"},
						"message","mBurning",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {175594},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBurning",
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end

-- Thunderlord Beast-Tender
do
	local data = {
		version = 1,
		key = "blackrocktrash6",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Thunderlord Beast-Tender"],
		triggers = {
			scan = {80423}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {80423},
			--defeat = 80423,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		onstart = {
			{

			},
		},
		alerts = {
			-- Inform
			iElectricalStorm = {
				varname = format(L.alert["%s %s, %s!"],SN[162663],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[162663],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[162663],
				sound = "ALERT12",
				desc = 162663,
				flashscreen = true,
				throttle = 1.5,
			},	
		},
		events = {
			-- Electrical Storm
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162663},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iElectricalStorm",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {162663},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iElectricalStorm",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {162663},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iElectricalStorm",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end

-- Iron Taskmaster
do
	local data = {
		version = 1,
		key = "blackrocktrash7",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Iron Taskmaster"],
		triggers = {
			scan = {80708}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {80708},
			--defeat = 80708,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},		
		messages = {
			mHeldToTask = {
				varname = format(L.alert["%s %s %s!"],SN[163121],L.alert["on"],L.alert["Boss"]),
				type = "message",
				text = format(L.alert["%s %s #5#!"],SN[163121],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 163121,
				icon = ST[163121],
			},			
		},
		onstart = {
			{

			},
		},
		alerts = {
			iHeldToTask = {
				varname = format(L.alert["%s %s %s, %s!"],L.alert["Enrage"],L.alert["on"],L.alert["Boss"],L.alert["Dispell"]),
				type = "inform",
				text = format(L.alert["%s %s #5#, %s!"],L.alert["Enrage"],L.alert["on"],L.alert["Dispell"]),
				time = 2,
				color1 = "RED",
				icon = ST[163121],
				sound = "ALERT11",
				desc = 163121,
				flashscreen = true,
				--throttle = 3,
			},
		},
		events = {
			-- HeldToTask
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163121},
				execute = {
					{
						"expect",{"&removeenrage&","==","true"},
						"alert","iHeldToTask",
					},
					{
						"expect",{"&removeenrage&","==","false"},
						"message","mHeldToTask",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end

-- Workshop Guardian
do
	local data = {
		version = 2,
		key = "blackrocktrash8",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Workshop Guardian"],
		triggers = {
			scan = {87411}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {87411},
			--defeat = 87411,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},
		messages = {
			mGrievousMortalWounds = {
				varname = format(L.alert["%s %s %s (2)"],SN[175624],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[175624],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[175624],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 175624,
				icon = ST[175624],
				throttle = 5,
				exdps = true,
			},
		},		
		onstart = {
			{

			},
		},
		alerts = {
			-- Inform
			iSpinningBlade = {
				varname = format(L.alert["%s %s, %s!"],SN[175643],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[175643],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[175643],
				sound = "ALERT12",
				desc = 175643,
				flashscreen = true,
				throttle = 1.5,
			},	
			-- Debuff
			GrievousMortalWoundsDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175624]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[175624]),
				text2 = format(L.alert["#5# (1): %s"],SN[175624]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[175624]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[175624]),
				time = 60,
				color1 = "RED",
				desc = 175624,
				icon = ST[175624],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- GrievousMortalWounds
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175624},
				execute = {
					{
						"message","mGrievousMortalWounds",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","GrievousMortalWoundsDebuff",
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"GrievousMortalWoundsDebuff", text = 2},
					},							
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {175624},
				execute = {
					{
						"message",{"mGrievousMortalWounds", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"GrievousMortalWoundsDebuff", text = 3},
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"GrievousMortalWoundsDebuff", text = 4},
					},						
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {175624},
				execute = {
					{
						"quash","GrievousMortalWoundsDebuff",
					},
				},
			},				
			-- Spinning Blade
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175643},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSpinningBlade",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {175643},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSpinningBlade",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {175643},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSpinningBlade",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","87411"},
						"stopcombat",
					},					
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end

-- Slag Behemoth
do
	local data = {
		version = 1,
		key = "blackrocktrash9",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		name = L.npc_BlackrockFoundry["Trash: Slag Behemoth"],
		triggers = {
			scan = {77504}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {77504},
			--defeat = 77504,
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},
		onstart = {
			{

			},
		},
		alerts = {
			wBlastWave = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156446]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156446]),
				time = 2,
				color1 = "RED",
				icon = ST[156446],
				sound = "ALERT11",
				desc = 156446,
			},		
		},
		events = {
			-- Blast Wave
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156446},
				execute = {
					{
						"alert","wBlastWave",
					},			
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","77504"},
						"stopcombat",
					},					
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end