local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1425)
do
	local data = {
		version = 2,
		key = "IronReaver",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-FelReaver.BLP:35:35",
		respawntime = 36,
		triggers = {
			scan = {90284}, 
			encounterid = 1785,
			ejid = 1425,
		},
		onactivate = {
			tracing = {
				90284,
				--powers={true},
				alternatepower={true},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 90284,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 600,
			timeflex = 600,
			timeheroic = 600,
			timemythic = 600,
		},
		userdata = {
			phase = 1,
			Artilleryunits = {type = "container", wipein = 3},
			barrageCount = 1,
			artilleryCount = 1,
			blitzCount = 1,
			poundingCount = 1,
			firebombCount = 1,
			Pounding = {54,24, loop = false, type = "series"},
			Barrage = {30,12,45, loop = false, type = "series"},
		},
		raidicons = {
			Artillerymark = {
				varname = SN[182280],
				type = "MULTIFRIENDLY",
				persist = 60,
				unit = "#5#",
				icon = 1,
				total = 8,
				reset = 15,
				desc = 182280,
				icon2 = ST[182280],
			},			
		},
		timers = {
			timerArtillery = {
				{
					"message","mArtillery",
				},
			},
		},	
		announces = { 
			Artillerysay = {
				varname = format(L.alert["%s %s %s!"],SN[182280],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[182280],L.alert["on"],L.alert["Me"]),
				desc = 182280,
				icon = ST[182280],
				--flashcolor = "RED",
				--flashscreen = true,
			},
		},
		messages = {
			mArtillery = {
				varname = format(L.alert["%s %s %s"],SN[182280],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Artilleryunits&"],SN[182280],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 182280,
				icon = ST[182280],
			},
			mPounding = {
				varname = format(L.alert["%s (2)"],SN[182020]),
				type = "message",
				text = format(L.alert["%s (<poundingCount>)"],SN[182020]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 182020,
				icon = ST[182020],
			},	
			mBlitz = {
				varname = format(L.alert["%s!"],SN[179889]),
				type = "message",
				text = format(L.alert["%s!"],SN[179889]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 179889,
				icon = ST[179889],
			},
			mFirebomb = {
				varname = format(L.alert["%s (2)"],SN[181999]),
				type = "message",
				text = format(L.alert["%s (<firebombCount>)"],SN[181999]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181999,
				icon = ST[181999],
			},			
		},
		onstart = {
			{
				"expect",{"&isranged&","==","true"},
				"openwindow",{"8"},
			},
			{
				"batchalert",{"BarrageCD","PoundingCD","BlitzCD","FullChargeCD"},
			},
		},
		alerts = {
			BarrageCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[185282]),
				type = "dropdown",
				text = "(<barrageCount>) "..format(L.alert["%s Cooldown"],SN[185282]),
				time = 13.3,
				time2 = "<Barrage>",
				time3 = 14.8,
				color1 = "GLOBAL",
				icon = ST[185282],
				desc = 185282,
			},
			PoundingCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[182020]),
				type = "dropdown",
				text = "(<poundingCount>) "..format(L.alert["%s Cooldown"],SN[182020]),
				time = 34.4,
				time2 = "<Pounding>",
				time3 = 35.8,
				color1 = "GLOBAL",
				icon = ST[182020],
				desc = 182020,
			},	
			BlitzCD = {
				varname = format(L.alert["%s Cooldown"],SN[179889]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[179889]),
				time = 64.4,
				time2 = 65.8,
				time3 = 58,
				color1 = "GLOBAL",
				icon = ST[179889],
				desc = 179889,
			},
			FirebombCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[181999]),
				type = "dropdown",
				text = "(<firebombCount>) "..format(L.alert["%s Cooldown"],SN[181999]),
				time = 11,
				time2 = 15,
				color1 = "GLOBAL",
				icon = ST[181999],
				desc = 181999,
			},
			FullChargeCD = {
				varname = format(L.alert["%s Cooldown"],SN[182055]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182055]),
				time = 139,
				time2 = 140,
				color1 = "GLOBAL",
				icon = ST[182055],
				desc = 182055,
			},	
			UnstableOrbCD = {
				varname = format(L.alert["%s Cooldown"],SN[182001]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182001]),
				time = 24,
				color1 = "GLOBAL",
				icon = ST[182001],
				desc = 182001,
				throttle = 2,
			},
			FallingSlamCD = {
				varname = format(L.alert["%s Cooldown"],SN[182066]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182066]),
				time = 54,
				color1 = "GLOBAL",
				icon = ST[182066],
				desc = 182066,
			},			
			-- Warning
			wBarrage = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[185282]),
				type = "simple",
				text = format(L.alert["%s %s (<barrageCount>)"],L.alert["Incoming"],SN[185282]),
				time = 2,
				color1 = "RED",
				icon = ST[185282],
				sound = "ALERT11",
				desc = 185282,
				flashscreen = true,
			},
			wFallingSlam = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182066]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182066]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[182066],
				sound = "ALERT10",
				desc = 182066,
			},
			wFullCharge = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182055]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182055]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[182055],
				sound = "ALERT10",
				desc = 182055,
			},				
			-- Inform
			iArtillery = {
				varname = format(L.alert["%s %s %s!"],SN[182280],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[182280],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[182280],
				sound = "ALERT12",
				desc = 182280,
				flashscreen = true,
			},
			iUnstableOrb = {
				varname = format(L.alert["%s %s %s!"],SN[182001],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[182001],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[182001],
				sound = "ALERT13",
				desc = 182001,
				flashscreen = true,
				throttle = 2,
			},
			iImmolation = {
				varname = format(L.alert["%s %s, %s!"],SN[182074],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[182074],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[182074],
				sound = "ALERT13",
				desc = 182074,
				flashscreen = true,
				throttle = 2,
			},				
			-- Casts
			PoundingAct = {
				varname = format(L.alert["%s Active"],SN[182020]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[182020]),
				time = 6,
				color1 = "TAN",
				icon = ST[182020],
				desc = 182020,
			},
			BarrageCast = {
				varname = format(L.alert["%s Casting"],SN[185282]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[185282]),
				time = 6,
				color1 = "RED",
				icon = ST[185282],
				desc = 185282,
				biggerbar = true,
			},	
			FallingSlamCast = {
				varname = format(L.alert["%s Casting"],SN[182066]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[182066]),
				time = 6,
				color1 = "TAN",
				icon = ST[182066],
				desc = 182066,
			},
			--[[FullChargeCast = {
				varname = format(L.alert["%s Casting"],SN[182055]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[182055]),
				time = 3,
				color1 = "YELLOW",
				icon = ST[182055],
				desc = 182055,
			},	--]]
			ArtilleryAct = {
				varname = format(L.alert["%s Active"],SN[182280]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[182280]),
				time = 13,
				color1 = "RED",
				icon = ST[182280],
				desc = 182280,
			},			
			-- Debuff
			ArtilleryDebuff = {
				varname = format(L.alert["%s Debuff"],SN[182280]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU&: %s"],SN[182280]),
				time = 13,
				color1 = "RED",
				desc = 182280,
				icon = ST[182280],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- Artillery
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182280},
				execute = {
					{
						"insert",{"Artilleryunits","#5#"},
						"canceltimer","timerArtillery",
						"scheduletimer",{"timerArtillery",0.3},
						--"raidicon","Artillerymark",
						"alert","ArtilleryDebuff",
					},
					{
						"expect",{"&count|Artilleryunits&","==","1"},
						"alert","ArtilleryAct",
					},					
					{
						"expect",{"#4#","==","&playerguid&"},
						"openwindow",{"20",nil,false,182280},
						"announce","Artillerysay",
						"alert","iArtillery",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REFRESH",
				spellid = {182280},
				execute = {
					{
						"insert",{"Artilleryunits","#5#"},
						"canceltimer","timerArtillery",
						"scheduletimer",{"timerArtillery",0.3},
						--"raidicon","Artillerymark",
						"alert","ArtilleryDebuff",
					},
					{
						"expect",{"&count|Artilleryunits&","==","1"},
						"alert","ArtilleryAct",
					},					
					{
						"expect",{"#4#","==","&playerguid&"},
						"openwindow",{"20",nil,false,182280},
						"announce","Artillerysay",
						"alert","iArtillery",
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {182280},
				execute = {
					--{
						--"removeraidicon","#5#",
					--},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
						"invoke",{
							{
								"expect",{"&isranged&","==","true"},
								"openwindow",{"8"},
							},
						},
					},					
				},
			},
			-- Pounding
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182020},
				execute = {
					{
						"set",{poundingCount = "INCR|1"},
						"message","mPounding",
						"alert","PoundingAct",
						"alert",{"PoundingCD", time = 2},
					},
				},
			},
			-- Barrage
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {185282},
				execute = {	
					{
						"set",{poundingCount = "INCR|1"},
						"batchalert",{"BarrageCast","wBarrage"},
						"alert",{"BarrageCD", time = 2},
					},				
				},
			},
			-- UnstableOrb
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182001},
				--dstisplayerunit = true,
				execute = {
					{
						"alert","UnstableOrbCD",
					},				
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iUnstableOrb",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {182001},
				--dstisplayerunit = true,
				execute = {
					{
						"alert","UnstableOrbCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iUnstableOrb",
					},	
				},
			},	
			-- Immolation
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182074},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iImmolation",
					},		
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {182074},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iImmolation",
					},		
				},
			},	
			-- FallingSlam
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182066},
				execute = {	
					{
						"batchalert",{"FallingSlamCast","wFallingSlam"},
					},				
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {182066},
				execute = {	
					{
						"set",{
							phase = 1,
							blitzCount = 1,
							barrageCount = 1,
							poundingCount = 1,
							artilleryCount = 1,
						},
						"alert",{"BlitzCD", time = 2},
						"alert",{"BarrageCD", time = 3},
						"alert",{"PoundingCD", time = 3},
						"alert",{"FullChargeCD", time = 3},
					},				
				},
			},				
			-- Blitz
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {179889},
				execute = {	
					{
						"message","mBlitz",
					},
					{
						"expect",{"<blitzCount>","==","2"},
						"alert",{"BlitzCD", time = 3},
						"set",{blitzCount = 1},
					},
					{
						"set",{blitzCount = "INCR|1"},
					},
				},
			},	
			-- FullCharge
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182055},
				execute = {	
					{
						"set",{phase = 2, firebombCount = 1},
						"batchquash",{"BlitzCD","UnstableOrbCD"},
						"batchalert",{"FallingSlamCD","FirebombCD","wFullCharge"},
						--"FullChargeCast"
					},				
				},
			},	
			-- Firebomb
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181999},
				execute = {	
					{
						"message","mFirebomb",
						"set",{firebombCount = "INCR|1"},
					},
					{
						"expect",{"<firebombCount>","<","4"},
						"alert",{"FirebombCD", time = 2},
					},					
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end