local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1392)
do
	local data = {
		version = 3,
		key = "Kormrok",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Kormok.BLP:35:35",
		triggers = {
			scan = {90435}, 
			encounterid = 1787,
			ejid = 1392,
		},
		onactivate = {
			tracing = {
				90435,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 90435,
		},
		windows = {
			proxwindow = true,
		},
		raidicons = {
			ExplosiveBurstmark = {
				varname = SN[181306],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#",
				icon = 1,
				desc = 181306,
				icon2 = ST[181306],
			},			
		},
		enrage = {

		},
		arrows = {
			ExplosiveBurstArrow = {
				varname = SN[181306],
				unit = "#5#",
				persist = 10,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[181306],
				range1 = 10,
				range2 = 20,
				range3 = 40,
				desc = 181306,
				icon = ST[181306],
			},	
		},		
		userdata = {
			poundCount = 0,
			tankDebuffCount = 1,
			FoulCrushunits = {type = "container", wipein = 3},
			empCounts = {type = "container"},
		},
		timers = {
			timerGraspingHands = {
				{
					"closewindow",
				},
			},
		},	
		announces = { 
			ExplosiveBurstsay = {
				varname = format(L.alert["%s %s %s!"],SN[181306],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181306],L.alert["on"],L.alert["Me"]),
				desc = 181306,
				icon = ST[181306],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT12",
			},
		},			
		messages = {
			mFoulCrush = {
				varname = format(L.alert["%s %s %s"],SN[181307],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU&"],SN[181307],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181307,
				icon = ST[181307],
			},
			mExplosiveBurst = {
				varname = format(L.alert["%s %s %s"],SN[181306],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU&"],SN[181306],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181306,
				icon = ST[181306],
			},
			mFelOutpouring = {
				varname = format(L.alert["%s!"],SN[181292]),
				type = "message",
				text = format(L.alert["%s!"],SN[181292]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181292,
				icon = ST[181292],
			},
			mEmpFelOutpouring = {
				varname = format(L.alert["%s!"],SN[181293]),
				type = "message",
				text = format(L.alert["%s!"],SN[181293]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181293,
				icon = ST[181293],
			},			
			mPoundInc = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[180244]),
				type = "message",
				text = format(L.alert["%s %s (<poundCount>)"],L.alert["Incoming"],SN[180244]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 180244,
				icon = ST[180244],
			},
			mPound = {
				varname = format(L.alert["%s (2)"],SN[180244]),
				type = "message",
				text = format(L.alert["%s (<poundCount>)"],SN[180244]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 180244,
				icon = ST[180244],
			},		
			mShadowEnergy = {
				varname = format(L.alert["%s!"],SN[180115]),
				type = "message",
				text = format(L.alert["%s!"],SN[180115]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 180115,
				icon = ST[180115],
			},	
			mExplosiveEnergy = {
				varname = format(L.alert["%s!"],SN[180116]),
				type = "message",
				text = format(L.alert["%s!"],SN[180116]),
				color1 = "CYAN",
				sound = "ALERT13",
				desc = 180116,
				icon = ST[180116],
			},	
			mFoulEnergy = {
				varname = format(L.alert["%s!"],SN[180117]),
				type = "message",
				text = format(L.alert["%s!"],SN[180117]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 180117,
				icon = ST[180117],
			},
			mFoulCrush = {
				varname = format(L.alert["%s"],SN[181307]),
				type = "message",
				text = format(L.alert["%s"],SN[181307]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181307,
				icon = ST[181307],
				exdps = true,
			},
			mSwat = {
				varname = format(L.alert["%s"],SN[181305]),
				type = "message",
				text = format(L.alert["%s"],SN[181305]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181305,
				icon = ST[181305],
			},				
		},
		onstart = {
			{
				"tabinsert",{"empCounts","hiddenPound","1"},
				"tabinsert",{"empCounts","shadow","0"},
				"tabinsert",{"empCounts","foul","0"},
				"tabinsert",{"empCounts","shadow","0"},
				"tabinsert",{"empCounts","phase","0"},
				"tabinsert",{"empCounts","explosive","0"},				
				"alert",{"StagesCD", time = 3},
			},
		},
		alerts = {
			PoundCD = {
				varname = format(L.alert["Next %s"],SN[179909]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[179909]),
				time = 39,
				time2 = 42,
				time3 = 52,
				time4 = 40,
				time5 = 62,
				time6 = 41,
				time7 = 31,
				color1 = "GLOBAL",
				icon = ST[179909],
				desc = 179909,
			},
			ExplosiveBurstCD = {
				varname = format(L.alert["%s Cooldown"],SN[181306]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181306]),
				time = 32,
				time2 = 50,
				time3 = 40,
				time4 = 21,
				color1 = "GLOBAL",
				icon = ST[181306],
				desc = 181306,
			},
			FoulCrushCD = {
				varname = format(L.alert["%s Cooldown"],SN[181307]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181307]),
				time = 42,
				time2 = 32,
				time3 = 40,
				time4 = 21,
				color1 = "GLOBAL",
				icon = ST[181307],
				desc = 181307,
			},			
			ExplosiveRunesCD = {
				varname = format(L.alert["%s Cooldown"],SN[181296]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181296]),
				time = 48,
				time2 = 55,
				time3 = 13,
				time4 = 69,
				color1 = "GLOBAL",
				icon = ST[181296],
				desc = 181296,
			},
			FelOutpouringCD = {
				varname = format(L.alert["%s Cooldown"],SN[181292]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181292]),
				time = 90,
				time2 = 82,
				time3 = 66,
				time4 = 14,
				time5 = 62,
				time6 = 46,
				color1 = "GLOBAL",
				icon = ST[181292],
				desc = 181292,
			},
			GraspingHandsCD = {
				varname = format(L.alert["%s Cooldown"],SN[181299]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181299]),
				time = 90,
				time2 = 65,
				time3 = 82,
				time4 = 54,
				time5 = 71,
				time6 = 43,
				time7 = 13,
				time8 = 121,
				time9 = 70,
				time10 = 56,
				color1 = "GLOBAL",
				icon = ST[181299],
				desc = 181299,
			},
			SwatCD = {
				varname = format(L.alert["%s Cooldown"],SN[181305]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181305]),
				time = 31,
				color1 = "GLOBAL",
				icon = ST[181305],
				desc = 181305,
			},	
			StagesCD = {
				varname = format(L.alert["Next %s"],SN[180068]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[180068]),
				time = 124,
				time2 = 114,
				time3 = 12.5,
				color1 = "GLOBAL",
				icon = ST[180068],
				desc = 180068,
			},				
			-- Warning
			wExplosiveRunes = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181296]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181296]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[181296],
				sound = "ALERT11",
				desc = 181296,
				--flashscreen = true,
			},
			wGraspingHands = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181299]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181299]),
				time = 2,
				color1 = "RED",
				icon = ST[181299],
				sound = "ALERT10",
				desc = 181299,
				--flashscreen = true,
			},
			wEnrage = {
				varname = format(L.alert["%s!"],SN[186882]),
				type = "simple",
				text = format(L.alert["%s!"],SN[186882]),
				time = 2,
				color1 = "RED",
				icon = ST[186882],
				sound = "ALERT10",
				desc = 186882,
			},			
			-- Inform
		
			-- Casts
			ExplosiveRunesInc = {
				varname = format(L.alert["%s Incoming"],SN[181296]),
				type = "centerpopup",
				text = format(L.alert["%s Incoming"],SN[181296]),
				time = 4,
				color1 = "RED",
				icon = ST[181296],
				desc = 181296,
			},
			PoundInc = {
				varname = "(2) "..format(L.alert["%s Incoming"],SN[180244]),
				type = "centerpopup",
				text = "(<poundCount>) "..format(L.alert["%s Incoming"],SN[180244]),
				time = 5,
				color1 = "ORANGE",
				icon = ST[180244],
				desc = 180244,
			},				
			-- Debuff
			ExplosiveBurstDebuff = {
				varname = format(L.alert["%s Debuff"],SN[181306]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU&: %s"],SN[181306]),
				time = 10,
				color1 = "ORANGE",
				desc = 181306,
				icon = ST[181306],
				tag = "#5#",
				exdps = true,				
			},
		},
		events = {
			-- ExplosiveBurst
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181306},
				execute = {
					{
						"alert","ExplosiveBurstDebuff",
						"message","mExplosiveBurst",
						"raidicon","ExplosiveBurstmark",
						"set",{tankDebuffCount = "INCR|1"},
					},
					{
						"expect",{"<tankDebuffCount>","==","2"},
						"alert","ExplosiveBurstCD",
					},
					{
						"expect",{"<tankDebuffCount>","==","3"},
						"alert",{"ExplosiveBurstCD", time = 2},
					},					
					{
						"expect",{"<tankDebuffCount> <tankDebuffCount>","~=","2 3"},
						"alert",{"ExplosiveBurstCD", time = 3},
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","ExplosiveBurstsay", 
						"openwindow",{"40",nil,false,181306},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"arrow","ExplosiveBurstArrow",
						"openwindow",{"40","#5#",false,181306},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181306},
				execute = {
					{
						"closewindow",
						"removeraidicon","#5#",
					},
				},
			},
			-- FoulCrush
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181307},
				execute = {
					{
						"set",{tankDebuffCount = "INCR|1"},
						"message","mFoulCrush",
					},
					{
						"expect",{"<tankDebuffCount>","==","2"},
						"alert","FoulCrushCD",
					},
					{
						"expect",{"<tankDebuffCount>","==","3"},
						"alert",{"FoulCrushCD", time = 2},
					},					
					{
						"expect",{"<tankDebuffCount> <tankDebuffCount>","~=","2 3"},
						"alert",{"FoulCrushCD", time = 3},
					},						
				},
			},	
			-- FelOutpouring
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181292},
				execute = {
					{
						"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","isfirst","false"},
						"alert","FelOutpouringCD",
						"message","mFelOutpouring",
					},
					{
						"expect",{"&tabread|empCounts|isfirst&","~=","true"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","2"},
								"alert",{"FelOutpouringCD", time = 2},
							},
							{
								"expect",{"&tabread|empCounts|phase&","~=","2"},
								"alert",{"FelOutpouringCD", time = 3},
							},	
							{
								"message","mFelOutpouring",
							},
						},
					},
				},
			}, -- Empowered FelOutpouring
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181293},
				execute = {
					{
						"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","isfirst","false"},
						"alert","FelOutpouringCD",
						"message","mEmpFelOutpouring",
					},
					{
						"expect",{"&tabread|empCounts|isfirst&","~=","true"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","2"},
								"alert",{"FelOutpouringCD", time = 2},
							},
							{
								"expect",{"&tabread|empCounts|phase&","~=","2"},
								"alert",{"FelOutpouringCD", time = 3},
							},
							{
								"message","mEmpFelOutpouring",
							},
						},
					},
				},
			},				
			-- ExplosiveRunes
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181296, 181297},
				execute = {
					{
						"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","isfirst","false"},
						"alert","GraspingHandsCD",
					},
					{
						"expect",{"&tabread|empCounts|isfirst&","~=","true"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","1"},
								"alert",{"GraspingHandsCD", time = 8},
							},
							{
								"expect",{"&tabread|empCounts|phase&","==","3"},
								"alert",{"GraspingHandsCD", time = 9},
							},							
							{
								"expect",{"&tabread|empCounts|phase& &tabread|empCounts|phase&","~=","1 3"},
								"alert",{"FelOutpouringCD", time = 10},
							},
							{
								"message","mEmpFelOutpouring",
							},
						},
					},				
					{
						"batchalert",{"ExplosiveRunesInc","ExplosiveRunesCD","wExplosiveRunes"},
					},			
				},
			},
			-- GraspingHands
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181299, 181300},
				execute = {	
					{
						"openwindow",{"4",nil,false,181299},
					},			
				},
			},		
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181299, 181300},
				execute = {	
					{
						"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","isfirst","false"},
						"alert","GraspingHandsCD",
					},
					{
						"expect",{"&tabread|empCounts|isfirst&","~=","true"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","3"},
								"alert",{"GraspingHandsCD", time = 2},
							},
							{
								"expect",{"&tabread|empCounts|phase&","~=","1"},
								"alert",{"GraspingHandsCD", time = 3},
							},	
							{
								"expect",{"&tabread|empCounts|phase& &tabread|empCounts|phase&","~=","1 3"},
								"alert",{"GraspingHandsCD", time = 4},
							},								
						},
					},
					{
						"alert","wGraspingHands",
						"canceltimer","timerGraspingHands",
						"scheduletimer",{"timerGraspingHands",4},
					},
				},
			},		
			-- Pound
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {180244},
				execute = {	
					{
						"set",{poundCount = "INCR|1"},
						"alert","PoundInc",
						"message","mPoundInc",
						"openwindow",{"5",nil,false,180244},
					},			
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {180244},
				execute = {
					{
						"tabupdate",{"empCounts","hiddenPound","INCR|1"},
					},
					{
						"expect",{"&tabread|empCounts|hiddenPound&","==","2"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","3"},
								"alert",{"PoundCD", time = 2},
							},
							{
								"expect",{"&tabread|empCounts|phase&","~=","3"},
								"alert",{"PoundCD", time = 3},
							},							
						},
					},
					{
						"expect",{"&tabread|empCounts|hiddenPound&","~=","2"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|phase&","==","3"},
								"alert",{"PoundCD", time = 4},
							},
							{
								"expect",{"&tabread|empCounts|phase&","~=","3"},
								"alert",{"PoundCD", time = 5},
							},							
						},
					},
					{
						--"set",{poundCount = "INCR|1"},
						"message","mPound",
					},			
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {180244},
				execute = {
					{
						"closewindow",
					},
				},
			},
			-- Swat
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181305},
				execute = {	
					{
						"message","mSwat",
						"set",{tankDebuffCount = "INCR|1"},
					},	
					{
						"expect",{"<tankDebuffCount>","<","4"},
						"alert","ExplosiveBurstCD",
					},
					{
						"expect",{"<tankDebuffCount>",">","3"},
						"alert",{"ExplosiveBurstCD", time = 2},
					},							
				},
			},	
			-- EnergyBuffs
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180115}, -- Shadow Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","shadow","4"},
						"tabupdate",{"empCounts","phase","3"},
						"tabupdate",{"empCounts","isFirst","true"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"set",{tankDebuffCount = 1},
					},				
					--{
					--	"expect",{"&mythic&","==","false"},
					--	"tabupdate",{"empCounts","foul","0"},
					--	"tabupdate",{"empCounts","explosive","0"},
					--},
					{
						"message","mShadowEnergy",
						"alert",{"FelOutpouringCD", time = 4},
						"alert",{"PoundCD", time = 6},
						"alert","SwatCD",
						"alert","StagesCD",
					},
					{
						"expect",{"&tabread|empCounts|explosive&",">","0"},
						"alert",{"ExplosiveRunesCD", time = 2},
					},
					{
						"expect",{"&tabread|empCounts|foul&",">","0"},
						"alert",{"GraspingHandsCD", time = 5},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180116}, -- Explosive Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","explosive","4"},
						"tabupdate",{"empCounts","phase","1"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"tabupdate",{"empCounts","isFirst","true"},
						"set",{tankDebuffCount = 1},
					},				
					--{
					--	"expect",{"&mythic&","==","false"},
					--	"tabupdate",{"empCounts","foul","0"},
					--	"tabupdate",{"empCounts","shadow","0"},
					--},
					{
						"message","mExplosiveEnergy",
						"alert",{"ExplosiveRunesCD", time = 3},
						"alert",{"ExplosiveBurstCD", time = 4},
						"alert",{"PoundCD", time = 7},
						"alert",{"StagesCD", time = 2},
					},		
					{
						"expect",{"&tabread|empCounts|shadow&",">","0"},
						"alert",{"FelOutpouringCD", time = 5},
					},
					{
						"expect",{"&tabread|empCounts|foul&",">","0"},
						"alert",{"GraspingHandsCD", time = 6},
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180117}, -- Foul Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","foul","4"},
						"tabupdate",{"empCounts","phase","2"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"tabupdate",{"empCounts","isFirst","true"},
						"set",{tankDebuffCount = 1},
					},				
				--	{
				--		"expect",{"&mythic&","==","false"},
				--		"tabupdate",{"empCounts","explosive","0"},
				--		"tabupdate",{"empCounts","shadow","0"},
				--	},
					{
						"message","mFoulEnergy",
						"alert",{"GraspingHandsCD", time = 7},
						"alert",{"FoulCrushCD", time = 4},
						"alert",{"PoundCD", time = 7},
						"alert",{"StagesCD", time = 2},
					},	
					{
						"expect",{"&tabread|empCounts|shadow&",">","0"},
						"alert",{"FelOutpouringCD", time = 6},
					},
					{
						"expect",{"&tabread|empCounts|explosive&",">","0"},
						"alert",{"ExplosiveRunesCD", time = 4},
					},	
				},
			},	
			-- Enrage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186882}, 
				execute = {
					{
						"alert","wEnrage",
					},
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end