local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1447)
do
	local data = {
		version = 1,
		key = "Xhulhorac",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Xhulhorac.BLP:35:35",
		triggers = {
			scan = {93068}, 
			encounterid = 1800,
			ejid = 1447,
		},
		onactivate = {
			tracing = {
				93068,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 93068,
		},
		windows = {
			proxwindow = true,
		},
		arrows = {
			ChainsOfFelarrow = {
				varname = SN[186500],
				multiunit = "&list|ChainsOfFelunits&",
				persist = 30,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[186500],
				range1 = 5,
				range2 = 15,
				range3 = 30,
				desc = 186500,
				icon = ST[186500],
			},		
		},				
		enrage = {

		},
		userdata = {
			Surgeunits = {type = "container", wipein = 3},
			ChainsOfFelunits = {type = "container", wipein = 3},
			Adds = {type = "container"},
			Addsguid = "",			
		},
		timers = {
			timerSurge = {
				{
					"message","mSurge",
				},
			},
			timerChainsOfFel = {
				{
					"message","mChainsOfFel",
				},
			},			
		},	
		announces = { 
			Surgesay = {
				varname = format(L.alert["%s %s %s!"],SN[186407],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[186407],L.alert["on"],L.alert["Me"]),
				desc = 186407,
				icon = ST[186407],
				flashcolor = "RED",
				flashscreen = true,	
			},
			ChainsOfFelsay = {
				varname = format(L.alert["%s %s %s!"],SN[186500],L.alert["on"],L.alert["Me"]),
				type = "YELL",
				msg = format(L.alert["%s %s %s!"],SN[186500],L.alert["on"],L.alert["Me"]),
				desc = 186500,
				icon = ST[186500],
				sound = "ALERT12",
			},			
		},			
		messages = {
			mSurge = {
				varname = format(L.alert["%s %s %s"],SN[186407],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Surgeunits&"],SN[186407],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 186407,
				icon = ST[186407],
			},	
			mChainsOfFel = {
				varname = format(L.alert["%s %s %s"],SN[186500],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|ChainsOfFelunits&"],SN[186500],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 186500,
				icon = ST[186500],
			},				
			mTouched = {
				varname = format(L.alert["%s %s %s"],SN[186134],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU&"],SN[186134],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 186134,
				icon = ST[186134],
			},
			mFelsingedWastingVoid = {
				varname = format(L.alert["%s %s %s (1)"],SN[186073],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU& (1)"],SN[186073],L.alert["on"]),
				text2 = format(L.alert["%s %s &dstname_or_YOU& (#11#)"],SN[186073],L.alert["on"]),
				color1 = "TEAL",
				sound = "ALERT13",
				desc = 186073,
				icon = ST[186073],
			},	
			mFelblazeFlurryWitheringGaze = {
				varname = format(L.alert["%s %s %s (1)"],SN[186448],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU& (1)"],SN[186448],L.alert["on"]),
				text2 = format(L.alert["%s %s &dstname_or_YOU& (#11#)"],SN[186448],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 186448,
				icon = ST[186448],
				exdps = true,
				exhealer = true,
			},	
			mOverwhelmingChaos = {
				varname = format(L.alert["%s %s %s (1)"],SN[187204],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU& (1)"],SN[187204],L.alert["on"]),
				text2 = format(L.alert["%s %s &dstname_or_YOU& (#11#)"],SN[187204],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 187204,
				icon = ST[187204],
			},	
			mVanguardAkkelion = {
				varname = format(L.alert["%s Spawns"],EJSN[11691]),
				type = "message",
				text = format(L.alert["%s Spawns"],EJSN[11691]),
				color1 = "CYAN",
				sound = "ALERT13",
				--ability = 11691,
				icon = EJST[11691],
			},
			mOmnus = {
				varname = format(L.alert["%s Spawns"],EJSN[11688]),
				type = "message",
				text = format(L.alert["%s Spawns"],EJSN[11688]),
				color1 = "CYAN",
				sound = "ALERT13",
				--ability = 11688,
				icon = EJST[11688],
			},	
			mUnstableVoidfiend = {
				varname = format(L.alert["%s Spawns"],EJSN[11714]),
				type = "message",
				text = format(L.alert["%s Spawns"],EJSN[11714]),
				color1 = "CYAN",
				sound = "ALERT13",
				--ability = 11714,
				icon = EJST[11714],
			},				
		},
		onstart = {
			{
				"batchalert",{"FelStrikeCD","FelSurgeCD"},
			},
		},
		alerts = {
			FelStrikeCD = {
				varname = format(L.alert["%s Cooldown"],SN[186271]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[186271]),
				time = 8,
				time2 = 14.5,
				color1 = "GLOBAL",
				icon = ST[186271],
				desc = 186271,
				exdps = true,
			},
			FelSurgeCD = {
				varname = format(L.alert["%s Cooldown"],SN[186407]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[186407]),
				time = 15,
				time2 = 30,
				color1 = "GLOBAL",
				icon = ST[186407],
				desc = 186407,
			},
			ChainsOfFelCD = {
				varname = format(L.alert["%s Cooldown"],SN[186500]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[186500]),
				time = 23,
				color1 = "GLOBAL",
				icon = ST[186500],
				desc = 186500,
			},
			FelblazeFlurryWitheringGazeCD = {
				varname = format(L.alert["%s Cooldown"],SN[186448]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[186448]),
				time = 15,
				color1 = "GLOBAL",
				icon = ST[186448],
				desc = 186448,
			},
			BlackHoleCD = {
				varname = format(L.alert["%s Cooldown"],SN[186546]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[186546]),
				time = 29,
				color1 = "GLOBAL",
				icon = ST[186546],
				desc = 186546,
			},			
			-- Warning
			wStrike = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[186271]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[186271]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[186271],
				sound = "ALERT10",
				desc = 186271,
				--flashscreen = true,
			},
			wBlackHole = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[186546]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[186546]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[186546],
				sound = "ALERT10",
				desc = 186546,
				--flashscreen = true,
			},				
			-- Casts
			TouchedAct = {
				varname = format(L.alert["%s Active"],SN[186134]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[186134]),
				time = 15,
				color1 = "RED",
				icon = ST[186134],
				desc = 186134,
			},			
			-- Debuff
			TouchedDebuff = {
				varname = format(L.alert["%s Debuff"],SN[186134]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU&: %s"],SN[186134]),
				time = 15,
				color1 = "ORANGE",
				desc = 186134,
				icon = ST[186134],
				tag = "#5#",
				exdps = true,				
			},	
			FelblazeFlurryWitheringGazeDebuff = {
				varname = format(L.alert["%s Debuff"],SN[186448]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU& (1): %s"],SN[186448]),
				text2 = format(L.alert["&dstname_or_YOU& (#11#): %s"],SN[186448]),
				time = 8,
				color1 = "RED",
				desc = 186448,
				icon = ST[186448],
				tag = "#5#",
				exdps = true,				
			},	
			--[[OverwhelmingChaosDebuff = {
				varname = format(L.alert["%s Debuff"],SN[187204]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU& (1): %s"],SN[187204]),
				text2 = format(L.alert["&dstname_or_YOU& (#11#): %s"],SN[187204]),
				time = 8,
				color1 = "RED",
				desc = 187204,
				icon = ST[187204],
				tag = "#5#",
				exdps = true,				
			},	--]]		
		},
		events = {
			-- Touched
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186134, 186135},
				execute = {
					{
						"alert","TouchedDebuff",
						"message","mTouched",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","TouchedAct",
					},
				},
			},
			-- FelsingedWastingVoid 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186073, 186063},
				dstisplayerunit = true,
				execute = {
					{
						"message","mFelsingedWastingVoid",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {186073, 186063},
				dstisplayerunit = true,
				execute = {
					{
						"message",{"mFelsingedWastingVoid", text = 2},
					},
				},
			},
			-- Surge
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186407, 186333},
				execute = {
					{
						"insert",{"Surgeunits","#5#"},
						"canceltimer","timerSurge",
						"scheduletimer",{"timerSurge",0.2},
					},
					{
						"expect",{"&count|Surgeunits&","==","1"},
						"alert",{"FelSurgeCD", time = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","Surgesay",
						"openwindow",{"10",nil,false,186407},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {186407, 186333},
				execute = {
					{
						"closewindow",
					},
				},
			},
			-- ChainsOfFel
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186500},
				execute = {
					{
						"insert",{"ChainsOfFelunits","#5#"},
						"canceltimer","timerChainsOfFel",
						"scheduletimer",{"timerChainsOfFel",0.2},
					},
					{
						"expect",{"&count|ChainsOfFelunits&","==","1"},
						"alert","ChainsOfFelCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","ChainsOfFelsay",
						"arrow","ChainsOfFelarrow",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {186500},
				execute = {
					{
						"removearrow","#5#",
					},
				},
			},			
			-- FelblazeFlurryWitheringGaze
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186448, 186785},
				execute = {
					{
						"alert","FelblazeFlurryWitheringGazeCD",
						"alert","FelblazeFlurryWitheringGazeDebuff",
						"message","mFelblazeFlurryWitheringGaze",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {186448, 186785},
				execute = {
					{
						"alert","FelblazeFlurryWitheringGazeCD",
						"alert",{"FelblazeFlurryWitheringGazeDebuff", text = 2},
						"message",{"mFelblazeFlurryWitheringGaze", text = 2},
					},
				},
			},
			-- Strike 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {186271, 186292},
				execute = {	
					{
						"alert","wStrike",
						"alert",{"FelStrikeCD", time = 2},
					},		
				},
			},
			-- OverwhelmingChaos
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {187204},
				execute = {
					{
					--	"alert","OverwhelmingChaosDebuff",
						"message","mOverwhelmingChaos",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {187204},
				execute = {
					{
					--	"alert",{"OverwhelmingChaosDebuff", text = 2},
						"message",{"mOverwhelmingChaos", text = 2},
					},
				},
			},
			-- BlackHole 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {186546},
				execute = {	
					{
						"alert","wBlackHole",
						"alert","BlackHoleCD",
					},		
				},
			},


			---------------------------------------
			
			{
                type = "event",
                event = "INSTANCE_ENCOUNTER_ENGAGE_UNIT",
                execute = {
					{
						--"debug",{"#1#","#2#","#3#","#4#","#5#"},
					},
					{
						"expect",{"&bossexist|11691&","==","true"}, -- Vanguard Akkelion
						"set",{Addsguid = "&bossexist|11691|true&"},
						"invoke",{
							{
								"expect",{"&tabread|Adds|<Addsguid>&","~=","true"},
								"tabinsert",{"Adds","<Addsguid>","true"},
								"message","mVanguardAkkelion",
							},
						},
					},
					{
						"expect",{"&bossexist|11688&","==","true"}, -- Omnus
						"set",{Addsguid = "&bossexist|11688|true&"},
						"invoke",{
							{
								"expect",{"&tabread|Adds|<Addsguid>&","~=","true"},
								"tabinsert",{"Adds","<Addsguid>","true"},
								"message","mOmnus",
							},
						},
					},
					{
						"expect",{"&bossexist|11714&","==","true"}, -- Unstable Voidfiend
						"set",{Addsguid = "&bossexist|11714|true&"},
						"invoke",{
							{
								"expect",{"&tabread|Adds|<Addsguid>&","~=","true"},
								"tabinsert",{"Adds","<Addsguid>","true"},
								"message","mUnstableVoidfiend",
							},
						},
					},						
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end