local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 3,
		key = "Xeritac",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["EverBloom: Xeritac"],
		triggers = {
			scan = {84550}, 
			emote = L.chat_PartyWoD["(Xeri'tac begins unleashing Toxic Spiderlings down on you!)"],
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1"	},
			unittracing = {	"boss1"},
			defeat = 84550,
		},
		userdata = {
			spiderlingCount = 8,
			phase2 = 0,
		},		
		messages = {
			mToxicSpiderlingLeft = {
				varname = format("2 %s %s",SN["ej10492"],L.alert["remaining"]),
				type = "message",
				text = format("<spiderlingCount> %s %s",SN["ej10492"],L.alert["remaining"]),
				color1 = "RED",
				icon = EJST[10492],
				sound = "ALERT13",
				ability = 10492,
			},
		},
		onstart = {

		},
		alerts = {
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[169233],
				sound = "ALERT13",
			},			
			wInhale = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[169233]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[169233]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[169233],
				sound = "ALERT10",
				desc = 169233,
			},
			wConsume = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[169248]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[169248]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[169248],
				sound = "ALERT10",
				desc = 169248,
			},	
			wGaseousVolley = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[169382]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[169382]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[169382],
				sound = "ALERT10",
				desc = 169382,
			},
			-- Inform
			iToxicGas = {
				varname = format(L.alert["%s %s, %s!"],SN[169223],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[169223],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[169223],
				flashscreen = true,
				throttle = 2,
				desc = 169223,
			},			
		},
		events = {
			-- Inhale
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {169233},
				execute = {
					{
						"alert","wInhale",
					},			
				},
			},
			-- Consume
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {169248},
				execute = {
					{
						"alert","wConsume",
					},			
				},
			},		
			-- GaseousVolley
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {169382},
				execute = {
					{
						"alert","wGaseousVolley",
					},			
				},
			},
			-- ToxicGas
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {169223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iToxicGas",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {169223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iToxicGas",
					},
				},
			},		
			-----------------------
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","84552"},
						"set",{spiderlingCount = "DECR|1"},
						"invoke",{
							{
								"expect",{"<spiderlingCount>",">","0"},
								"message","mToxicSpiderlingLeft",
							},
						},
					},		
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_TARGETABLE_CHANGED",
				execute = {	
					{
						"expect",{"<phase2>","==","0"},
						"set",{phase2 = "1"},
						"alert","Phase2",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end