local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Nokgar",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["IronDocks: Nokgar"],
		triggers = {
			scan = {81297, 81305}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1","boss2"	},
			unittracing = {	"boss1","boss2"},
			defeat = {	81297, 81305, 	}
		},
		userdata = {

		},	
		messages = {
			mRecklessProvocation = {
				varname = format(L.alert["%s %s %s"],SN[164426],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[164426],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 164426,
				icon = ST[164426],
			},			
		},
		onstart = {

		},
		alerts = {
			BurningArrowsCD = {
				varname = format(L.alert["%s Cooldown"],SN[164635]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[164635]),
				time = 25,
				color1 = "GLOBAL",
				icon = ST[164635],
				desc = 164635,
			},
			-- Warning
			wBurningArrows = {
				varname = format(L.alert["%s!"],SN[164635]),
				type = "simple",
				text = format(L.alert["%s!"],SN[164635]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[164635],
				sound = "ALERT10",
				desc = 164635,
			},
			-- Inform
			iEnrage = {
				varname = format(L.alert["%s %s %s!"],SN[164835],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[164835],
				desc = 164835,
			},
			iBurningArrows = {
				varname = format(L.alert["%s, %s!"],SN[164632],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s, %s!"],SN[164632],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[164632],
				sound = "ALERT10",
				desc = 164632,
				flashscreen = true,
				throttle = 3,
			},			
		},
		events = {
			-- RecklessProvocation
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164426},
				execute = {
					{
						"message","mRecklessProvocation",
					},						
				},
			},
			-- Enrage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164835},
				--dstnpcid = {81297},
				execute = {
					{
						"expect",{"&removeenrage&","==","true"},
						"alert","iEnrage",
					},					
				},
			},
			-- BurningArrows
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164632},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBurningArrows",
					},					
				},
			},			
			-------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#5#","==","164635"}, -- BurningArrows
						"expect",{"#1#","==","boss1"},
						"batchalert",{"BurningArrowsCD","wBurningArrows"},
					},	
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end