local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 3,
		key = "Kyrak",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["UBRS: Kyrak"],
		triggers = {
			scan = {76021,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	76021, 	},
			unittracing = {	"boss1",},
			defeat = 76021,
		},
		userdata = {
			DBMReset = 0,
		},
		timers = {
			timerDBMSyncReset  = {
				{
					"set",{DBMReset = "0"},	
				},
			},				
		},			
		messages = {
			mRejuvSerum = {
				varname = format(L.alert["%s %s %s"],SN[161203],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[161203],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 161203,
				icon = ST[161203],
				extank = true,
				exdps = true,				
			},
			mToxicFumes = {
				varname = format(L.alert["%s %s %s"],SN[162600],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[162600],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 162600,
				icon = ST[162600],
				extank = true,
				exdps = true,
			},
			mDeblitatingFixation = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[161199]),
				type = "message",
				text = format(L.alert["%s %s)"],L.alert["Incoming"],SN[161199]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 161199,
				icon = ST[161199],
				exdps = true,
			},			
		},
		onstart = {

		},
		alerts = {
			VilebloodSerumCD = {
				varname = format(L.alert["%s Cooldown"],SN[161209]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[161209]),
				time = 9.5,
				color1 = "GLOBAL",
				icon = ST[161209],
				desc = 161209,
			},
			-- Warning
			wVileSerum = {
				varname = format(L.alert["%s!"],SN[161209]),
				type = "simple",
				text = format(L.alert["%s!"],SN[161209]),
				time = 2,
				color1 = "TAN",
				icon = ST[161209],
				sound = "ALERT10",
				desc = 161209,
			},			
			-- Inform
			iRejuvSerum = {
				varname = format(L.alert["%s %s %s!"],SN[161203],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[161203],
				desc = 161203,
			},
			iToxicFumes = {
				varname = format(L.alert["%s %s %s!"],SN[162600],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "GOLD",
				sound = "ALERT10",
				icon = ST[162600],
				desc = 162600,
			},
			iDeblitatingFixation = {
				varname = format(L.alert["%s: %s"],SN[156854],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s: %s &bossname|boss1&"],SN[156854],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[156854],
				exhealer = true,
				exdps = true,
				desc = 156854,
			},	
			iVilebloodSerum = {
				varname = format(L.alert["%s %s, %s!"],SN[161288],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[161288],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[161288],
				flashscreen = true,
				throttle = 3,
				desc = 161288,
			},					
			-- Debuff
			RejuvSerumDebuff = {
				varname = format(L.alert["%s Debuff"],SN[161203]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[161203]),
				text2 = format(L.alert["#5#: %s"],SN[161203]),
				time = 30,
				color1 = "RED",
				icon = ST[161203],
				desc = 161203,
				tag = "#5#",
			},			
		},
		events = {
			-- RejuvSerum
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {161203},
				execute = {
					{
						"message","mRejuvSerum",
					},		
					{
						"expect",{"&dispell|magic&","==","true"},
						"alert","iRejuvSerum",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","RejuvSerumDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"RejuvSerumDebuff", text = 2},
					},					
				},
			},	
			-- ToxicFumes
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162600},
				execute = {
					{
						"message","mToxicFumes",
						"alert","iToxicFumes",
					},		
				},
			},
			-- DeblitatingFixation
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {161199},
				execute = {
					{
						"alert","iDeblitatingFixation",
						"message","mDeblitatingFixation",
					},			
				},
			},	
			-- VilebloodSerum
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {161288},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iVilebloodSerum",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {161288},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iVilebloodSerum",
					},
				},
			},	

			---------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#5#","==","161209"}, -- VileSerum
						"expect",{"#1#","==","boss1"},
						"dbmsync",{"VileSerum"},
					},				
				},
			},		
			{
				type = "event",
				event = "CHAT_MSG_ADDON", 
				execute = {
					{
						"expect",{"#1#","==","D4"},
						"expect",{"<DBMReset>","~=","1"},
						"set",{DBMReset = "1"},
						"invoke",{
							{
								"expect",{"&sync|DBM|#2#&","==","VileSerum"},
								"batchalert",{"VilebloodSerumCD","wVileSerum"},
							},
							{
								"scheduletimer",{"timerDBMSyncReset",3},							
							},
						},
					},					
				},
			},	
			
		},
	}

	DXE:RegisterEncounter(data)
end